package org.linda.Database
//import scala.collection.mutable.Map
import org.linda.Core._
import org.linda.LindaTypes.LindaType
import java.util.Random
//import scala.collection.mutable.{SynchronizedMap,HashMap}

class ServerDatabase extends Database{
  //private val db = scala.collection.mutable.Map[String, List[List[LindaType]]] () 
  
  
  // out primitive realization
  override def out (signature : String, tuple: List[LindaType]) : Boolean = 
    {
     //if list with such signature exists, add new tuple to it
      if (db.contains(signature)) db(signature) = tuple :: db(signature)  
    //if list with such signature does not exist create new list of tuples
    else db(signature) = List[List[LindaType]](tuple) 
  
    
    println(db)
    
    
    true
    }
  	
  
  // in primitive realization
 override def in (antiTuple : List[LindaType]) : List[LindaType]= 
  {
    //println(antiTuple)
    //println(" db in")
    val signature = LindaTuple.getSignature(antiTuple)
    //println(signature)
    //println(signature)
    //if (db.contains(signature)) println("NO! signature contained!") 
    //println(find(antiTuple))
    //db.synchronized {
    
      //while (!(db.contains(signature)) && (find(antiTuple).isEmpty)) {wait();println("wait")}
    
    val tuple = chooseTuple(find(antiTuple))
    //if database has only one tuple with such signature, delete entire List 
    if (db(signature).length == 1)
    	 db - signature
    //if database has more than tuple with such signature, delete choosen tuple
    else
        db(signature) = deleteTuple(tuple,db(signature))
      
      println(db)
      
      tuple
      //}
    //else {println("no such signature");List()}
    //List()
    }

  // rd primitive realization
 override def rd (antiTuple : List[LindaType]) : List[LindaType]= 
  {
    //println(antiTuple)
    //println(" db in")
    val signature = LindaTuple.getSignature(antiTuple)
    //println(signature)
    //println(signature)
    //if (db.contains(signature)) println("NO! signature contained!") 
    //println(find(antiTuple))
    //db.synchronized {
    
      //while (!(db.contains(signature)) && (find(antiTuple).isEmpty)) {wait();println("wait")}
    
    val tuple = chooseTuple(find(antiTuple))
      
      //println(db)
      
      tuple
      //}
    //else {println("no such signature");List()}
    //List()
    }  

}

