package org.linda.Client
import org.linda.LindaTypes._
import org.linda.Core._
import java.io._
import java.net.{InetAddress,ServerSocket,Socket,SocketException}
import java.util.Random

class Client {

  //try {  
  val ia = InetAddress.getByName("localhost")
  
  

  //true
//  }
 // catch {
  //    case e: IOException =>
  //      e.printStackTrace()
  //  }
 

  
  def out (input : Any) : Boolean = 
    {
    val socket = new Socket(ia, 9998)
    val outStream = new ObjectOutputStream(
      new DataOutputStream(socket.getOutputStream()))
    // val inStream = new DataInputStream(socket.getInputStream())
    //println(matchTuple (input))
    val lindaTuple = createLindaTuple(input)
    //println(("out",getSignature(lindaTuple),lindaTuple))
    outStream.writeObject(("out",LindaTuple.getSignature(lindaTuple),lindaTuple))
    //outStream.writeObject("out",matchTuple(input),input)
    //outStream.flush()
    outStream.close()
    true
    }

 
  def in (input : Any) : List[LindaType] = {
    val socket = new Socket(ia, 9998)
    val outStream = new ObjectOutputStream(new DataOutputStream(socket.getOutputStream()))
    val inStream = new ObjectInputStream (new DataInputStream(socket.getInputStream()))
    val antiTuple = createLindaTuple(input)
    outStream.writeObject(("in","",antiTuple))
    val tuple = inStream.readObject().asInstanceOf[List[LindaType]]
    outStream.close()
    inStream.close()
    tuple
    //List()
    }
  
  def createLindaTuple (input : Any) : List[LindaType] = {
    //val LindaTuple = 
    input match {
    case input : LindaType => List(input)
    case (a,b) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType])
    case (a,b,c) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType])
    case (a,b,c,d) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType])
    case (a,b,c,d,e) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType])
    case (a,b,c,d,e,f) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g,h) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g,h,i) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType],u.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType],u.asInstanceOf[LindaType],v.asInstanceOf[LindaType])
    case _ => List ()
    }
  }
  
  
  def matchTuple (input : Any) : String = 
    input match {
       case input : LindaType => 
        {
        //val tuple = input.asInstanceOf[Tuple1[LindaType]]
        //val signature = tuple._1.getType
        input.getType
        }
      case (a,b) => 
        {
        val tuple = input.asInstanceOf[Tuple2[LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType
        signature
        }
      case (a,b,c) => 
        {
        val tuple = input.asInstanceOf[Tuple3[LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType
        signature
        }
      case (a,b,c,d) => 
        {
        val tuple = input.asInstanceOf[Tuple4[LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType
        signature
        }
      case (a,b,c,d,e) => 
        {
        val tuple = input.asInstanceOf[Tuple5[LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType
        signature
        }  
      case (a,b,c,d,e,f) => 
        {
        val tuple = input.asInstanceOf[Tuple6[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType
        signature
        }
      case (a,b,c,d,e,f,g) => 
        {
        val tuple = input.asInstanceOf[Tuple7[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType
        signature
        }
       case (a,b,c,d,e,f,g,h) => 
        {
        val tuple = input.asInstanceOf[Tuple8[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i) => 
        {
        val tuple = input.asInstanceOf[Tuple9[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j) => 
        {
        val tuple = input.asInstanceOf[Tuple10[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType
        signature
        }  
       case (a,b,c,d,e,f,g,h,i,j,k) => 
        {
        val tuple = input.asInstanceOf[Tuple11[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l) => 
        {
        val tuple = input.asInstanceOf[Tuple12[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m) => 
        {
        val tuple = input.asInstanceOf[Tuple13[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType
        signature
        }
        case (a,b,c,d,e,f,g,h,i,j,k,l,m,n) => 
        {
        val tuple = input.asInstanceOf[Tuple14[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) => 
        {
        val tuple = input.asInstanceOf[Tuple15[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType
        signature
        }
        case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) => 
        {
        val tuple = input.asInstanceOf[Tuple16[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q) => 
        {
        val tuple = input.asInstanceOf[Tuple17[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r) => 
        {
        val tuple = input.asInstanceOf[Tuple18[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType +" " + tuple._18.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s) => 
        {
        val tuple = input.asInstanceOf[Tuple19[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType +" " + tuple._18.getType +" " + tuple._19.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t) => 
        {
        val tuple = input.asInstanceOf[Tuple20[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType +" " + tuple._18.getType +" " + tuple._19.getType +" " + tuple._20.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u) => 
        {
        val tuple = input.asInstanceOf[Tuple21[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType +" " + tuple._18.getType +" " + tuple._19.getType +" " + tuple._20.getType +" " + tuple._21.getType
        signature
        }
       case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v) => 
        {
        val tuple = input.asInstanceOf[Tuple22[LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType,LindaType]]
        val signature = tuple._1.getType + " "+ tuple._2.getType +" " + tuple._3.getType +" " + tuple._4.getType +" " + tuple._5.getType +" " + tuple._6.getType +" " + tuple._7.getType +" " + tuple._8.getType +" " + tuple._9.getType +" " + tuple._10.getType +" " + tuple._11.getType +" " + tuple._12.getType +" " + tuple._13.getType +" " + tuple._14.getType +" " + tuple._15.getType +" " + tuple._16.getType +" " + tuple._17.getType +" " + tuple._18.getType +" " + tuple._19.getType +" " + tuple._20.getType +" " + tuple._21.getType +" " + tuple._22.getType
        signature
        }
       case _ => "matched nothing"
      
    }
}

