package org.linda.Core
import org.linda.LindaTypes._

object LindaTuple {

  //getting signature of the tuple
  def getSignature (tuple : List[LindaType]) : String ={
    var output = ""
    tuple.foreach(arg => output = output +" " + arg.getType)
    output.drop(1)
    }
  
  //converting LindaTuple (List[LindaType]) from general type Any (in this case)
  def createLindaTuple (input : Any) : List[LindaType] = {
    //val LindaTuple = 
    try {
    input match {
    case input : LindaType => List(input)
    case (a,b) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType])
    case (a,b,c) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType])
    case (a,b,c,d) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType])
    case (a,b,c,d,e) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType])
    case (a,b,c,d,e,f) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g,h) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType])
    case (a,b,c,d,e,f,g,h,i) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType],u.asInstanceOf[LindaType])
	case (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v) => List(a.asInstanceOf[LindaType],b.asInstanceOf[LindaType],c.asInstanceOf[LindaType],d.asInstanceOf[LindaType],e.asInstanceOf[LindaType],f.asInstanceOf[LindaType],g.asInstanceOf[LindaType],h.asInstanceOf[LindaType],i.asInstanceOf[LindaType],j.asInstanceOf[LindaType],k.asInstanceOf[LindaType],l.asInstanceOf[LindaType],m.asInstanceOf[LindaType],n.asInstanceOf[LindaType],o.asInstanceOf[LindaType],p.asInstanceOf[LindaType],q.asInstanceOf[LindaType],r.asInstanceOf[LindaType],s.asInstanceOf[LindaType],t.asInstanceOf[LindaType],u.asInstanceOf[LindaType],v.asInstanceOf[LindaType])
    case _ => List ()
    }
    }
    catch {
      case e: ClassCastException => 
        println("Error: Input values must be derived from base class LindaType")
        List()
    }
  }
}
