package org.linda.LindaTypes

case class LindaDouble (double : Double) extends LindaType {
  val Value = double
  
 //getting class identifier
  override def getType = "double"
  override def toString = Value+""
    
  
  //implementing base arithmetical operations for class
  def + (that: LindaDouble): LindaDouble =
    new LindaDouble(Value + that.Value)
  def + (i: Double):LindaDouble =
    new LindaDouble (Value + i)
  def - (that: LindaDouble) : LindaDouble = 
    new LindaDouble (Value - that.Value)
  def - (i: Double):LindaDouble =
    new LindaDouble (Value - i)
  def * (that: LindaDouble) : LindaDouble = 
    new LindaDouble (Value * that.Value)
  def * (i: Double):LindaDouble =
    new LindaDouble (Value * i)
  def / (that: LindaDouble) : LindaDouble = 
    new LindaDouble (Value / that.Value)
  def / (i: Double):LindaDouble =
    new LindaDouble (Value / i)
  def % (that: LindaDouble) : LindaDouble = 
    new LindaDouble (Value % that.Value)
  def % (i: Double):LindaDouble =
    new LindaDouble (Value % i)
  
  //defining equals method
  override def equals (other : Any) = other match {
    case that: LindaDouble =>
      (that canEqual this) &&
      (this.Value == that.Value)
    case _ =>
      false
    }
  
  //helper method for object equality
  def canEqual (other: Any) = other.isInstanceOf[LindaDouble]
}
