package org.linda.LindaTypes

case class LindaFloat (float : Float) extends LindaType {
  val Value = float
  
 //getting class identifier
  override def getType = "float"
  override def toString = Value+""
    
  
  //implementing base arithmetical operations for class
  def + (that: LindaFloat): LindaFloat =
    new LindaFloat(Value + that.Value)
  def + (i: Float):LindaFloat =
    new LindaFloat (Value + i)
  def - (that: LindaFloat) : LindaFloat = 
    new LindaFloat (Value - that.Value)
  def - (i: Float):LindaFloat =
    new LindaFloat (Value - i)
  def * (that: LindaFloat) : LindaFloat = 
    new LindaFloat (Value * that.Value)
  def * (i: Float):LindaFloat =
    new LindaFloat (Value * i)
  def / (that: LindaFloat) : LindaFloat = 
    new LindaFloat (Value / that.Value)
  def / (i: Float):LindaFloat =
    new LindaFloat (Value / i)
  def % (that: LindaFloat) : LindaFloat = 
    new LindaFloat (Value % that.Value)
  def % (i: Float):LindaFloat =
    new LindaFloat (Value % i)
  
  //defining equals method
  override def equals (other : Any) = other match {
    case that: LindaFloat =>
      (that canEqual this) &&
      (this.Value == that.Value)
    case _ =>
      false
    }
  
  //helper method for object equality
  def canEqual (other: Any) = other.isInstanceOf[LindaFloat]
}
