package org.linda.LindaTypes

case class LindaLong (long : Long) extends LindaType {
  val Value = long
  
 //getting class identifier
  override def getType = "long"
  override def toString = Value+""
    
  
  //implementing base arithmetical operations for class
  def + (that: LindaLong): LindaLong =
    new LindaLong(Value + that.Value)
  def + (i: Long):LindaLong =
    new LindaLong (Value + i)
  def - (that: LindaLong) : LindaLong = 
    new LindaLong (Value - that.Value)
  def - (i: Long):LindaLong =
    new LindaLong (Value - i)
  def * (that: LindaLong) : LindaLong = 
    new LindaLong (Value * that.Value)
  def * (i: Long):LindaLong =
    new LindaLong (Value * i)
  def / (that: LindaLong) : LindaLong = 
    new LindaLong (Value / that.Value)
  def / (i: Long):LindaLong =
    new LindaLong (Value / i)
  def % (that: LindaLong) : LindaLong = 
    new LindaLong (Value % that.Value)
  def % (i: Long):LindaLong =
    new LindaLong (Value % i)
  
  //defining equals method
  override def equals (other : Any) = other match {
    case that: LindaLong =>
      (that canEqual this) &&
      (this.Value == that.Value)
    case _ =>
      false
    }
  
  //helper method for object equality
  def canEqual (other: Any) = other.isInstanceOf[LindaLong]
}
