package org.linda.LindaTypes

class LindaString (input : String) extends LindaType{
  val Value = input

  //getting class identifier
  def getType = "string"
  override def toString = Value+""
  
  //defining equals method
  override def equals (other : Any) = other match {
    case that: LindaString =>
      (that canEqual this) &&
      (this.Value == that.Value)
    case _ =>
      false
    }
  
  //helper method for object equality
  def canEqual (other: Any) = other.isInstanceOf[LindaString]
}
